﻿#include <iostream>
using namespace std;

class Point
{
private:
    int x, y;
public:
    Point(int x = 0, int y = 0);
    Point& operator+(Point& Q);  //    
    Point& operator-(Point& Q);
    int operator*(Point& Q);
    Point& operator*(int n);
    void operator++();
    friend int norma(Point&);
    friend bool Equal(Point& A, Point& B);
    friend ostream& operator<<(ostream& stream, Point& P);
    friend istream& operator>>(istream& stream, Point& P);
};


Point::Point(int x, int y)
{
    this->x = x; this->y = y;
}

Point& Point::operator+(Point& Q)
{
    Point* P = new Point(x + Q.x, y + Q.y);
    return *P;
}

Point& Point::operator-(Point& Q)
{
    Point* P = new Point(x - Q.x, y - Q.y);
    return *P;
}

int Point::operator*(Point& Q)
{
     return x*Q.x+y*Q.y;
}

Point& Point::operator*(int n)
{
    Point* P = new Point(x*n, y*n);
    return *P;
}

void Point::operator++()
{
    x++; y++;
}

int norma(Point& P)
{
    return P.x * P.x + P.y * P.y;

}

bool Equal(Point& A, Point& B)
{
    return A.x == B.x && A.y == B.y;
}


ostream& operator<<(ostream& stream, Point& P)
{
    return stream << "(" << P.x << "," << P.y << ")";
}

istream& operator>>(istream& stream, Point& P)
{
    return stream >> P.x >> P.y;
}

int main()
{
    Point A(1, 2);
    Point B(3, 4);
    Point D(2, 3);
    Point C; C = A + B;
    C = C * 10;
    ++A;
    cout << A * B << endl;
    cout << C << " Norma=" << norma(C) << endl;
    cout << (C - A - B)*100 << endl;
    cout << Equal(A,D) << endl;
    cin >> D;
    cout << D << " |" << norma(D) << "|" << endl;
}
